diff --git a/gcc/cp/decl2.c b/gcc/cp/decl2.c
index d67ced0..069919c 100644
--- a/gcc/cp/decl2.c
+++ b/gcc/cp/decl2.c
@@ -764,10 +764,11 @@ finish_static_data_member_decl (tree decl,
 	 t = CP_TYPE_CONTEXT (t))
       if (TYPE_UNNAMED_P (t))
 	{
-	  if (permerror (DECL_SOURCE_LOCATION (decl),
-			 "static data member %qD in unnamed class", decl))
-	    inform (DECL_SOURCE_LOCATION (TYPE_NAME (t)),
-		    "unnamed class defined here");
+	  diagnostic_group d;
+	  if (d.permerror (DECL_SOURCE_LOCATION (decl),
+			   "static data member %qD in unnamed class", decl))
+	    d.inform (DECL_SOURCE_LOCATION (TYPE_NAME (t)),
+		      "unnamed class defined here");
 	  break;
 	}
 
@@ -4286,10 +4287,12 @@ no_linkage_error (tree decl)
     vec_safe_push (no_linkage_decls, decl);
   else if (TYPE_UNNAMED_P (t))
     {
-      bool d = false;
+      bool warned = false;
+      diagnostic_group d;
       if (cxx_dialect >= cxx11)
-	d = permerror (DECL_SOURCE_LOCATION (decl), "%q#D, declared using "
-		       "unnamed type, is used but never defined", decl);
+	warned
+	  = d.permerror (DECL_SOURCE_LOCATION (decl), "%q#D, declared using "
+			 "unnamed type, is used but never defined", decl);
       else if (DECL_EXTERN_C_P (decl))
 	/* Allow this; it's pretty common in C.  */;
       else if (VAR_P (decl))
@@ -4297,17 +4300,19 @@ no_linkage_error (tree decl)
 	   no linkage can only be used to declare extern "C"
 	   entities.  Since it's not always an error in the
 	   ISO C++ 90 Standard, we only issue a warning.  */
-	d = warning_at (DECL_SOURCE_LOCATION (decl), 0, "unnamed type "
-			"with no linkage used to declare variable %q#D with "
-			"linkage", decl);
+	warned
+	  = d.warning_at (DECL_SOURCE_LOCATION (decl), 0, "unnamed type "
+			  "with no linkage used to declare variable %q#D with "
+			  "linkage", decl);
       else
-	d = permerror (DECL_SOURCE_LOCATION (decl), "unnamed type with no "
-		       "linkage used to declare function %q#D with linkage",
-		       decl);
-      if (d && is_typedef_decl (TYPE_NAME (t)))
-	inform (DECL_SOURCE_LOCATION (TYPE_NAME (t)), "%q#D does not refer "
-		"to the unqualified type, so it is not used for linkage",
-		TYPE_NAME (t));
+	warned
+	  = d.permerror (DECL_SOURCE_LOCATION (decl), "unnamed type with no "
+			 "linkage used to declare function %q#D with linkage",
+			 decl);
+      if (warned && is_typedef_decl (TYPE_NAME (t)))
+	d.inform (DECL_SOURCE_LOCATION (TYPE_NAME (t)), "%q#D does not refer "
+		  "to the unqualified type, so it is not used for linkage",
+		  TYPE_NAME (t));
     }
   else if (cxx_dialect >= cxx11)
     {
@@ -5208,17 +5213,18 @@ cp_warn_deprecated_use (tree decl, tsubst_flags_t complain)
       && DECL_NONSTATIC_MEMBER_FUNCTION_P (decl)
       && copy_fn_p (decl))
     {
+      diagnostic_group d;
       /* Don't warn about system library classes (c++/86342).  */
       if (!DECL_IN_SYSTEM_HEADER (decl))
-	warned = warning (OPT_Wdeprecated_copy,
-			  "implicitly-declared %qD is deprecated", decl);
+	warned = d.warning (OPT_Wdeprecated_copy,
+			    "implicitly-declared %qD is deprecated", decl);
       if (warned)
 	{
 	  tree ctx = DECL_CONTEXT (decl);
 	  tree other = classtype_has_user_copy_or_dtor (ctx);
-	  inform (DECL_SOURCE_LOCATION (other),
-		  "because %qT has user-provided %qD",
-		  ctx, other);
+	  d.inform (DECL_SOURCE_LOCATION (other),
+		    "because %qT has user-provided %qD",
+		    ctx, other);
 	}
     }
   else
diff --git a/gcc/cp/error.c b/gcc/cp/error.c
index c49f4d7..20f2aa1 100644
--- a/gcc/cp/error.c
+++ b/gcc/cp/error.c
@@ -4269,13 +4269,15 @@ qualified_name_lookup_error (tree scope, tree name,
     }
   else if (scope != global_namespace)
     {
-      error_at (location, "%qD is not a member of %qD", name, scope);
-      if (!suggest_alternative_in_explicit_scope (location, name, scope))
-	suggest_alternatives_for (location, name, false);
+      diagnostic_group d;
+      d.error_at (location, "%qD is not a member of %qD", name, scope);
+      if (!suggest_alternative_in_explicit_scope (&d, location, name, scope))
+	suggest_alternatives_for (&d, location, name, false);
     }
   else
     {
-      error_at (location, "%<::%D%> has not been declared", name);
-      suggest_alternatives_for (location, name, true);
+      diagnostic_group d;
+      d.error_at (location, "%<::%D%> has not been declared", name);
+      suggest_alternatives_for (&d, location, name, true);
     }
 }
diff --git a/gcc/cp/friend.c b/gcc/cp/friend.c
index 2c9c12f..485add2 100644
--- a/gcc/cp/friend.c
+++ b/gcc/cp/friend.c
@@ -304,13 +304,14 @@ make_friend_class (tree type, tree friend_type, bool complain)
       if (TYPE_TEMPLATE_INFO (friend_type)
 	  && !PRIMARY_TEMPLATE_P (TYPE_TI_TEMPLATE (friend_type)))
 	{
-	  error ("%qT is not a template", friend_type);
-	  inform (location_of (friend_type), "previous declaration here");
+	  diagnostic_group d;
+	  d.error ("%qT is not a template", friend_type);
+	  d.inform (location_of (friend_type), "previous declaration here");
 	  if (TYPE_CLASS_SCOPE_P (friend_type)
 	      && CLASSTYPE_TEMPLATE_INFO (TYPE_CONTEXT (friend_type))
 	      && currently_open_class (TYPE_CONTEXT (friend_type)))
-	    inform (input_location, "perhaps you need explicit template "
-		    "arguments in your nested-name-specifier");
+	    d.inform (input_location, "perhaps you need explicit template "
+		      "arguments in your nested-name-specifier");
 	  return;
 	}
     }
@@ -384,19 +385,21 @@ make_friend_class (tree type, tree friend_type, bool complain)
 		}
 	      if (template_member_p && !DECL_CLASS_TEMPLATE_P (decl))
 		{
-		  error ("%qT is not a member class template of %qT",
-			 name, ctype);
-		  inform (DECL_SOURCE_LOCATION (decl),
-			  "%qD declared here", decl);
+		  diagnostic_group d;
+		  d.error ("%qT is not a member class template of %qT",
+			   name, ctype);
+		  d.inform (DECL_SOURCE_LOCATION (decl),
+			    "%qD declared here", decl);
 		  return;
 		}
 	      if (!template_member_p && (TREE_CODE (decl) != TYPE_DECL
 					 || !CLASS_TYPE_P (TREE_TYPE (decl))))
 		{
-		  error ("%qT is not a nested class of %qT",
-			 name, ctype);
-		  inform (DECL_SOURCE_LOCATION (decl),
-			  "%qD declared here", decl);
+		  diagnostic_group d;
+		  d.error ("%qT is not a nested class of %qT",
+			   name, ctype);
+		  d.inform (DECL_SOURCE_LOCATION (decl),
+			    "%qD declared here", decl);
 		  return;
 		}
 
@@ -635,14 +638,17 @@ do_friend (tree ctype, tree declarator, tree decl,
 	    {
 	      static int explained;
 	      bool warned;
-
-	      warned = warning (OPT_Wnon_template_friend, "friend declaration "
+	      diagnostic_group d;
+	      warned
+		= d.warning_at (input_location, OPT_Wnon_template_friend,
+				"friend declaration "
 				"%q#D declares a non-template function", decl);
 	      if (! explained && warned)
 		{
-		  inform (input_location, "(if this is not what you intended, make sure "
-			  "the function template has already been declared "
-			  "and add <> after the function name here) ");
+		  d.inform (input_location,
+			    "(if this is not what you intended, make sure "
+			    "the function template has already been declared "
+			    "and add <> after the function name here) ");
 		  explained = 1;
 		}
 	    }
diff --git a/gcc/cp/init.c b/gcc/cp/init.c
index 94f8fdd..d072a13 100644
--- a/gcc/cp/init.c
+++ b/gcc/cp/init.c
@@ -915,10 +915,11 @@ perform_member_init (tree member, tree init)
 	    {
 	      /* TYPE_NEEDS_CONSTRUCTING can be set just because we have a
 		 vtable; still give this diagnostic.  */
-	      if (permerror (DECL_SOURCE_LOCATION (current_function_decl),
-			     "uninitialized const member in %q#T", type))
-		inform (DECL_SOURCE_LOCATION (member),
-			"%q#D should be initialized", member );
+	      diagnostic_group d;
+	      if (d.permerror (DECL_SOURCE_LOCATION (current_function_decl),
+			       "uninitialized const member in %q#T", type))
+		d.inform (DECL_SOURCE_LOCATION (member),
+			  "%q#D should be initialized", member );
 	    }
 	  finish_expr_stmt (build_aggr_init (decl, init, flags,
 					     tf_warning_or_error));
@@ -932,16 +933,18 @@ perform_member_init (tree member, tree init)
 	  /* member traversal: note it leaves init NULL */
 	  if (TYPE_REF_P (type))
 	    {
-	      if (permerror (DECL_SOURCE_LOCATION (current_function_decl),
-			     "uninitialized reference member in %q#T", type))
-		inform (DECL_SOURCE_LOCATION (member),
-			"%q#D should be initialized", member);
+	      diagnostic_group d;
+	      if (d.permerror (DECL_SOURCE_LOCATION (current_function_decl),
+			       "uninitialized reference member in %q#T", type))
+		d.inform (DECL_SOURCE_LOCATION (member),
+			  "%q#D should be initialized", member);
 	    }
 	  else if (CP_TYPE_CONST_P (type))
 	    {
-	      if (permerror (DECL_SOURCE_LOCATION (current_function_decl),
-			     "uninitialized const member in %q#T", type))
-		  inform (DECL_SOURCE_LOCATION (member),
+	      diagnostic_group d;
+	      if (d.permerror (DECL_SOURCE_LOCATION (current_function_decl),
+			       "uninitialized const member in %q#T", type))
+		d.inform (DECL_SOURCE_LOCATION (member),
 			  "%q#D should be initialized", member );
 	    }
 
@@ -3255,14 +3258,15 @@ build_new_1 (vec<tree, va_gc> **placement, tree type, tree nelts,
 	  || CP_DECL_CONTEXT (alloc_fn) == global_namespace)
       && !aligned_allocation_fn_p (alloc_fn))
     {
-      if (warning (OPT_Waligned_new_, "%<new%> of type %qT with extended "
-		   "alignment %d", elt_type, TYPE_ALIGN_UNIT (elt_type)))
+      diagnostic_group d;
+      if (d.warning (OPT_Waligned_new_, "%<new%> of type %qT with extended "
+		     "alignment %d", elt_type, TYPE_ALIGN_UNIT (elt_type)))
 	{
-	  inform (input_location, "uses %qD, which does not have an alignment "
-		  "parameter", alloc_fn);
+	  d.inform (input_location, "uses %qD, which does not have an "
+		    "alignment parameter", alloc_fn);
 	  if (!aligned_new_threshold)
-	    inform (input_location, "use %<-faligned-new%> to enable C++17 "
-				    "over-aligned new support");
+	    d.inform (input_location, "use %<-faligned-new%> to enable C++17 "
+		      "over-aligned new support");
 	}
     }
 
@@ -3831,16 +3835,20 @@ build_vec_delete_1 (tree base, tree maxindex, tree type,
 
   if (!COMPLETE_TYPE_P (type))
     {
-      if ((complain & tf_warning)
-	  && warning (OPT_Wdelete_incomplete,
-		      "possible problem detected in invocation of "
-		      "delete [] operator:"))
-       {
-         cxx_incomplete_type_diagnostic (base, type, DK_WARNING);
-         inform (input_location, "neither the destructor nor the "
-                 "class-specific operator delete [] will be called, "
-                 "even if they are declared when the class is defined");
-       }
+      if (complain & tf_warning)
+	{
+	  diagnostic_group d;
+	  if (d.warning (OPT_Wdelete_incomplete,
+			 "possible problem detected in invocation of "
+			 "delete [] operator:"))
+	    {
+	      // FIXME:
+	      cxx_incomplete_type_diagnostic (base, type, DK_WARNING);
+	      d.inform (input_location, "neither the destructor nor the "
+			"class-specific operator delete [] will be called, "
+			"even if they are declared when the class is defined");
+	    }
+	}
       /* This size won't actually be used.  */
       size_exp = size_one_node;
       goto no_destructor;
@@ -4712,16 +4720,19 @@ build_delete (tree otype, tree addr, special_function_kind auto_delete,
 	  complete_type (type);
 	  if (!COMPLETE_TYPE_P (type))
 	    {
-	      if ((complain & tf_warning)
-		  && warning (OPT_Wdelete_incomplete,
-			      "possible problem detected in invocation of "
-			      "delete operator:"))
+	      if (complain & tf_warning)
 		{
-		  cxx_incomplete_type_diagnostic (addr, type, DK_WARNING);
-		  inform (input_location,
-			  "neither the destructor nor the class-specific "
-			  "operator delete will be called, even if they are "
-			  "declared when the class is defined");
+		  diagnostic_group d;
+		  if (d.warning (OPT_Wdelete_incomplete,
+				 "possible problem detected in invocation of "
+				 "delete operator:"))
+		    {
+		      cxx_incomplete_type_diagnostic (addr, type, DK_WARNING);
+		      d.inform (input_location,
+				"neither the destructor nor the class-specific "
+				"operator delete will be called, even if they "
+				"are declared when the class is defined");
+		    }
 		}
 	    }
 	  else if (deleting && warn_delnonvdtor
diff --git a/gcc/cp/lex.c b/gcc/cp/lex.c
index bd5d507..95ff2d4 100644
--- a/gcc/cp/lex.c
+++ b/gcc/cp/lex.c
@@ -499,8 +499,9 @@ unqualified_name_lookup_error (tree name, location_t loc)
     {
       if (!objc_diagnose_private_ivar (name))
 	{
-	  error_at (loc, "%qD was not declared in this scope", name);
-	  suggest_alternatives_for (loc, name, true);
+	  diagnostic_group d;
+	  d.error_at (loc, "%qD was not declared in this scope", name);
+	  suggest_alternatives_for (&d, loc, name, true);
 	}
       /* Prevent repeated error messages by creating a VAR_DECL with
 	 this NAME in the innermost block scope.  */
diff --git a/gcc/cp/name-lookup.c b/gcc/cp/name-lookup.c
index 0faf739..a6db0f9 100644
--- a/gcc/cp/name-lookup.c
+++ b/gcc/cp/name-lookup.c
@@ -41,7 +41,8 @@ static cxx_binding *cxx_binding_make (tree value, tree type);
 static cp_binding_level *innermost_nonclass_level (void);
 static void set_identifier_type_value_with_scope (tree id, tree decl,
 						  cp_binding_level *b);
-static bool maybe_suggest_missing_std_header (location_t location, tree name);
+static bool maybe_suggest_missing_std_header (diagnostic_group *group,
+					      location_t location, tree name);
 
 /* Create an overload suitable for recording an artificial TYPE_DECL
    and another decl.  We use this machanism to implement the struct
@@ -2556,13 +2557,17 @@ check_extern_c_conflict (tree decl)
 
       if (mismatch)
 	{
-	  pedwarn (input_location, 0,
-		   "conflicting C language linkage declaration %q#D", decl);
-	  inform (DECL_SOURCE_LOCATION (old),
-		  "previous declaration %q#D", old);
-	  if (mismatch < 0)
-	    inform (input_location,
-		    "due to different exception specifications");
+	  diagnostic_group d;
+	  if (d.pedwarn (input_location, 0,
+			 "conflicting C language linkage declaration %q#D",
+			 decl))
+	    {
+	      d.inform (DECL_SOURCE_LOCATION (old),
+			"previous declaration %q#D", old);
+	      if (mismatch < 0)
+		d.inform (input_location,
+			  "due to different exception specifications");
+	    }
 	}
       else
 	{
@@ -2604,6 +2609,15 @@ c_linkage_bindings (tree name)
   return NULL_TREE;
 }
 
+/* FIXME.  */
+
+static void
+inform_shadowed (tree shadowed, diagnostic_group *group)
+{
+  group->inform (DECL_SOURCE_LOCATION (shadowed),
+		 "shadowed declaration is here");
+}
+
 /* DECL is being declared at a local scope.  Emit suitable shadow
    warnings.  */
 
@@ -2631,7 +2645,6 @@ check_local_shadow (tree decl)
       old_scope = binding->scope;
     }
 
-  tree shadowed = NULL_TREE;
   if (old
       && (TREE_CODE (old) == PARM_DECL
 	  || VAR_P (old)
@@ -2702,9 +2715,10 @@ check_local_shadow (tree decl)
 	       && old_scope == current_binding_level->level_chain
 	       && (old_scope->kind == sk_cond || old_scope->kind == sk_for))
 	{
-	  error ("redeclaration of %q#D", decl);
-	  inform (DECL_SOURCE_LOCATION (old),
-		  "%q#D previously declared here", old);
+	  diagnostic_group d;
+	  d.error ("redeclaration of %q#D", decl);
+	  d.inform (DECL_SOURCE_LOCATION (old),
+		    "%q#D previously declared here", old);
 	  return;
 	}
       /* C++11:
@@ -2724,9 +2738,10 @@ check_local_shadow (tree decl)
 		       || current_binding_level->level_chain->kind == sk_catch)
 		   && in_function_try_handler))
 	{
-	  if (permerror (input_location, "redeclaration of %q#D", decl))
-	    inform (DECL_SOURCE_LOCATION (old),
-		    "%q#D previously declared here", old);
+	  diagnostic_group d;
+	  if (d.permerror (input_location, "redeclaration of %q#D", decl))
+	    d.inform (DECL_SOURCE_LOCATION (old),
+		      "%q#D previously declared here", old);
 	  return;
 	}
 
@@ -2764,11 +2779,9 @@ check_local_shadow (tree decl)
       else
 	msg = "declaration of %qD shadows a previous local";
 
-      if (warning_at (input_location, warning_code, msg, decl))
-	{
-	  shadowed = old;
-	  goto inform_shadowed;
-	}
+      diagnostic_group d;
+      if (d.warning_at (input_location, warning_code, msg, decl))
+	inform_shadowed (old, &d);
       return;
     }
 
@@ -2793,14 +2806,12 @@ check_local_shadow (tree decl)
 	    || TYPE_PTRFN_P (TREE_TYPE (decl))
 	    || TYPE_PTRMEMFUNC_P (TREE_TYPE (decl)))
 	  {
-	    if (warning_at (input_location, OPT_Wshadow,
-			    "declaration of %qD shadows a member of %qT",
-			    decl, current_nonlambda_class_type ())
+	    diagnostic_group d;
+	    if (d.warning_at (input_location, OPT_Wshadow,
+			      "declaration of %qD shadows a member of %qT",
+			      decl, current_nonlambda_class_type ())
 		&& DECL_P (member))
-	      {
-		shadowed = member;
-		goto inform_shadowed;
-	      }
+	      inform_shadowed (member, &d);
 	  }
 	return;
       }
@@ -2815,20 +2826,15 @@ check_local_shadow (tree decl)
       && !instantiating_current_function_p ())
     /* XXX shadow warnings in outer-more namespaces */
     {
-      if (warning_at (input_location, OPT_Wshadow,
-		      "declaration of %qD shadows a global declaration",
-		      decl))
-	{
-	  shadowed = old;
-	  goto inform_shadowed;
-	}
+      diagnostic_group d;
+      if (d.warning_at (input_location, OPT_Wshadow,
+			"declaration of %qD shadows a global declaration",
+			decl))
+	inform_shadowed (old, &d);
       return;
     }
 
   return;
-
- inform_shadowed:
-  inform (DECL_SOURCE_LOCATION (shadowed), "shadowed declaration is here");
 }
 
 /* DECL is being pushed inside function CTX.  Set its context, if
@@ -2954,10 +2960,11 @@ set_local_extern_decl_linkage (tree decl, bool shadowed)
 		       && !comptypes (TREE_TYPE (decl), TREE_TYPE (other),
 				      COMPARE_REDECLARATION)))
 	    {
-	      if (permerror (DECL_SOURCE_LOCATION (decl),
-			     "local external declaration %q#D", decl))
-		inform (DECL_SOURCE_LOCATION (other),
-			"does not match previous declaration %q#D", other);
+	      diagnostic_group d;
+	      if (d.permerror (DECL_SOURCE_LOCATION (decl),
+			       "local external declaration %q#D", decl))
+		d.inform (DECL_SOURCE_LOCATION (other),
+			  "does not match previous declaration %q#D", other);
 	      break;
 	    }
 	}
@@ -5312,8 +5319,8 @@ has_using_namespace_std_directive_p ()
    suggest the best near-match, if there is one.  */
 
 void
-suggest_alternatives_for (location_t location, tree name,
-			  bool suggest_misspellings)
+suggest_alternatives_for (diagnostic_group *group, location_t location,
+			  tree name, bool suggest_misspellings)
 {
   vec<tree> candidates = vNULL;
   vec<tree> worklist = vNULL;
@@ -5350,9 +5357,10 @@ suggest_alternatives_for (location_t location, tree name,
 	      if (worklist.length () == limit)
 		{
 		  /* Unconditionally warn that the search was truncated.  */
-		  inform (location,
-			  "maximum limit of %d namespaces searched for %qE",
-			  limit, name);
+		  group->inform (location,
+				 "maximum limit of %d namespaces searched "
+				 "for %qE",
+				 limit, name);
 		  limited = true;
 		}
 	      else
@@ -5365,14 +5373,14 @@ suggest_alternatives_for (location_t location, tree name,
 
   if (candidates.length ())
     {
-      inform_n (location, candidates.length (),
-		"suggested alternative:",
-		"suggested alternatives:");
+      group->inform_n (location, candidates.length (),
+		       "suggested alternative:",
+		       "suggested alternatives:");
       for (unsigned ix = 0; ix != candidates.length (); ix++)
 	{
 	  tree val = candidates[ix];
 
-	  inform (location_of (val), "  %qE", val);
+	  group->inform (location_of (val), "  %qE", val);
 	}
       candidates.release ();
       return;
@@ -5384,20 +5392,21 @@ suggest_alternatives_for (location_t location, tree name,
      is one of the most common "std::" names, then it's probably a
      missing #include.  */
   if (has_using_namespace_std_directive_p ())
-    if (maybe_suggest_missing_std_header (location, name))
+    if (maybe_suggest_missing_std_header (group, location, name))
       return;
 
   /* Otherwise, consider misspellings.  */
   if (!suggest_misspellings)
     return;
   if (name_hint hint = lookup_name_fuzzy (name, FUZZY_LOOKUP_NAME,
-					  location))
+					  group, location))
     {
       /* Show a spelling correction.  */
       gcc_rich_location richloc (location);
 
       richloc.add_fixit_replace (hint.suggestion ());
-      inform (&richloc, "suggested alternative: %qs", hint.suggestion ());
+      group->inform (&richloc, "suggested alternative: %qs",
+		     hint.suggestion ());
     }
 }
 
@@ -5614,7 +5623,8 @@ get_cxx_dialect_name (enum cxx_dialect dialect)
    Return true iff a suggestion was offered.  */
 
 static bool
-maybe_suggest_missing_std_header (location_t location, tree name)
+maybe_suggest_missing_std_header (diagnostic_group *group, location_t location,
+				  tree name)
 {
   gcc_assert (TREE_CODE (name) == IDENTIFIER_NODE);
 
@@ -5628,16 +5638,16 @@ maybe_suggest_missing_std_header (location_t location, tree name)
     {
       const char *header = header_hint->header;
       maybe_add_include_fixit (&richloc, header);
-      inform (&richloc,
-	      "%<std::%s%> is defined in header %qs;"
-	      " did you forget to %<#include %s%>?",
-	      name_str, header, header);
+      group->inform (&richloc,
+		     "%<std::%s%> is defined in header %qs;"
+		     " did you forget to %<#include %s%>?",
+		     name_str, header, header);
     }
   else
     {
-      inform (&richloc,
-	      "%<std::%s%> is only available from %s onwards",
-	      name_str, get_cxx_dialect_name (header_hint->min_dialect));
+      group->inform (&richloc,
+		     "%<std::%s%> is only available from %s onwards",
+		     name_str, get_cxx_dialect_name (header_hint->min_dialect));
     }
   return true;
 }
@@ -5647,7 +5657,8 @@ maybe_suggest_missing_std_header (location_t location, tree name)
    Return true iff a suggestion was offered.  */
 
 static bool
-maybe_suggest_missing_header (location_t location, tree name, tree scope)
+maybe_suggest_missing_header (diagnostic_group *group, location_t location,
+			      tree name, tree scope)
 {
   if (scope == NULL_TREE)
     return false;
@@ -5656,7 +5667,7 @@ maybe_suggest_missing_header (location_t location, tree name, tree scope)
   /* We only offer suggestions for the "std" namespace.  */
   if (scope != std_node)
     return false;
-  return maybe_suggest_missing_std_header (location, name);
+  return maybe_suggest_missing_std_header (group, location, name);
 }
 
 /* Look for alternatives for NAME, an IDENTIFIER_NODE for which name
@@ -5665,7 +5676,8 @@ maybe_suggest_missing_header (location_t location, tree name, tree scope)
    Return true iff a suggestion was provided.  */
 
 bool
-suggest_alternative_in_explicit_scope (location_t location, tree name,
+suggest_alternative_in_explicit_scope (diagnostic_group *group,
+				       location_t location, tree name,
 				       tree scope)
 {
   /* Something went very wrong; don't suggest anything.  */
@@ -5675,7 +5687,7 @@ suggest_alternative_in_explicit_scope (location_t location, tree name,
   /* Resolve any namespace aliases.  */
   scope = ORIGINAL_NAMESPACE (scope);
 
-  if (maybe_suggest_missing_header (location, name, scope))
+  if (maybe_suggest_missing_header (group, location, name, scope))
     return true;
 
   cp_binding_level *level = NAMESPACE_LEVEL (scope);
@@ -5689,8 +5701,8 @@ suggest_alternative_in_explicit_scope (location_t location, tree name,
     {
       gcc_rich_location richloc (location);
       richloc.add_fixit_replace (fuzzy_name);
-      inform (&richloc, "suggested alternative: %qs",
-	      fuzzy_name);
+      group->inform (&richloc, "suggested alternative: %qs",
+		     fuzzy_name);
       return true;
     }
 
@@ -5834,7 +5846,7 @@ class macro_use_before_def : public deferred_diagnostic
   /* Factory function.  Return a new macro_use_before_def instance if
      appropriate, or return NULL. */
   static macro_use_before_def *
-  maybe_make (location_t use_loc, cpp_hashnode *macro)
+  maybe_make (diagnostic_group *group, location_t use_loc, cpp_hashnode *macro)
   {
     source_location def_loc = cpp_macro_definition_location (macro);
     if (def_loc == UNKNOWN_LOCATION)
@@ -5848,14 +5860,15 @@ class macro_use_before_def : public deferred_diagnostic
     if (!linemap_location_before_p (line_table, use_loc, def_loc))
       return NULL;
 
-    return new macro_use_before_def (use_loc, macro);
+    return new macro_use_before_def (group, use_loc, macro);
   }
 
  private:
   /* Ctor.  LOC is the location of the usage.  MACRO is the
      macro that was used.  */
-  macro_use_before_def (location_t loc, cpp_hashnode *macro)
-  : deferred_diagnostic (loc), m_macro (macro)
+  macro_use_before_def (diagnostic_group *group, location_t loc,
+			cpp_hashnode *macro)
+  : deferred_diagnostic (group, loc), m_macro (macro)
   {
     gcc_assert (macro);
   }
@@ -5864,7 +5877,7 @@ class macro_use_before_def : public deferred_diagnostic
   {
     if (is_suppressed_p ())
       return;
-
+    // FIXME: use group
     inform (get_location (), "the macro %qs had not yet been defined",
 	    (const char *)m_macro->ident.str);
     inform (cpp_macro_definition_location (m_macro),
@@ -5906,10 +5919,11 @@ suggest_rid_p  (enum rid rid)
    macro names, returning the best match as a const char *, or NULL if
    no reasonable match is found.
 
-   Use LOC for any deferred diagnostics.  */
+   Use GROUP and LOC for any deferred diagnostics.  */
 
 name_hint
-lookup_name_fuzzy (tree name, enum lookup_name_fuzzy_kind kind, location_t loc)
+lookup_name_fuzzy (tree name, enum lookup_name_fuzzy_kind kind,
+		   diagnostic_group *group, location_t loc)
 {
   gcc_assert (TREE_CODE (name) == IDENTIFIER_NODE);
 
@@ -5919,7 +5933,7 @@ lookup_name_fuzzy (tree name, enum lookup_name_fuzzy_kind kind, location_t loc)
     = get_cp_stdlib_header_for_name (IDENTIFIER_POINTER (name));
   if (header_hint)
     return name_hint (NULL,
-		      new suggest_missing_header (loc,
+		      new suggest_missing_header (group, loc,
 						  IDENTIFIER_POINTER (name),
 						  header_hint));
 
@@ -5957,7 +5971,7 @@ lookup_name_fuzzy (tree name, enum lookup_name_fuzzy_kind kind, location_t loc)
       cpp_hashnode *macro = bmm.blithely_get_best_candidate ();
       if (macro && (macro->flags & NODE_BUILTIN) == 0)
 	return name_hint (NULL,
-			  macro_use_before_def::maybe_make (loc, macro));
+			  macro_use_before_def::maybe_make (group, loc, macro));
     }
 
   /* Try the "starts_decl_specifier_p" keywords to detect
